<?php
/*======================================================================*\
|| #################################################################### ||
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2012 Fillip Hannisdal AKA Revan/NeoRevan/Belazor 	  # ||
|| # All Rights Reserved. 											  # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # ---------------------------------------------------------------- # ||
|| # You are not allowed to use this on your server unless the files  # ||
|| # you downloaded were done so with permission.					  # ||
|| # ---------------------------------------------------------------- # ||
|| #################################################################### ||
\*======================================================================*/

// #################### DEFINE IMPORTANT CONSTANTS #######################
define('THIS_SCRIPT', 'ajaxthreads');
define('IN_AJAXTHREADS', true);

if (isset($_REQUEST['do']) AND $_REQUEST['do'] == 'ajax')
{
	define('CSRF_PROTECTION', true);
	define('LOCATION_BYPASS', 1);
	define('NOPMPOPUP', 1);
	define('VB_ENTRY', 'ajax.php');
	define('SESSION_BYPASS', true);
	define('VB_ENTRY_TIME', microtime(true));
}

// ################### PRE-CACHE TEMPLATES AND DATA ######################
// get special phrase groups
$phrasegroups = array('dbtech_ajaxthreads', 'user', 'album');

// get templates used by all actions
$globaltemplates = array(
	'dbtech_ajaxthreads',
);

// pre-cache templates used by specific actions
$actiontemplates = array();

// get special data templates from the datastore
require_once('./dbtech/ajaxthreads/includes/specialtemplates.php');
$specialtemplates = $extracache;

// ############################### default do value ######################
if (empty($_REQUEST['do']))
{
	$_REQUEST['do'] = $_GET['do'] = 'main';
}

// ######################### REQUIRE BACK-END ############################
require_once('./global.php');

if (!class_exists('vB_Template'))
{
	// Ensure we have this
	require_once(DIR . '/dbtech/ajaxthreads/includes/class_template.php');
}

if (!class_exists('AJAXTHREADS'))
{
	eval(standard_error($vbphrase['dbtech_ajaxthreads_deactivated']));
}

if ($_REQUEST['do'] == 'devinfo' AND $_REQUEST['devkey'] == 'dbtech')
{
	AJAXTHREADS::outputJSON(array(
		'version' 		=> AJAXTHREADS::$version,
		'versionnumber' => AJAXTHREADS::$versionnumber,
		'pro'			=> AJAXTHREADS::$isPro,
		'vbversion'		=> $vbulletin->versionnumber
	));
}

// ########################################################################
// ######################### START MAIN SCRIPT ############################
// ########################################################################

if (!empty($_POST['do']))
{
	// $_POST requests take priority
	$action = $_POST['do'];
}
else if (!empty($_GET['do']))
{
	// We had a GET request instead
	$action = $_GET['do'];
}
else
{
	// No request
	$action = 'main';
}

// Strip non-valid characters
$action = preg_replace('/[^\w-]/i', '', $action);

if (!$vbulletin->options['dbtech_ajaxthreads_active'])
{
	// Sb is shut off
	eval(standard_error($vbulletin->options['dbtech_ajaxthreads_closedreason']));
}

if (AJAXTHREADS::$permissions['isbanned'])
{
	// Can't view Activity
	print_no_permission();
}

// begin navbits
$navbits = array('ajaxthreads.php' . $vbulletin->session->vars['sessionurl_q'] => $vbphrase['dbtech_ajaxthreads_ajaxthreads']);

// Core page template
$page_template = 'dbtech_ajaxthreads';

if (!file_exists(DIR . '/dbtech/ajaxthreads/actions/' . $action . '.php'))
{
	if (!file_exists(DIR . '/dbtech/ajaxthreads_pro/actions/' . $action . '.php'))
	{
		// Throw error from invalid action
		eval(standard_error(fetch_error('dbtech_ajaxthreads_error_x', $vbphrase['dbtech_ajaxthreads_invalid_action'])));
	}
	else
	{
		// Include the selected file
		include_once(DIR . '/dbtech/ajaxthreads_pro/actions/' . $action . '.php');	
	}
}
else
{
	// Include the selected file
	include_once(DIR . '/dbtech/ajaxthreads/actions/' . $action . '.php');	
}

if (intval($vbulletin->versionnumber) == 3)
{
	// Create navbits
	$navbits = construct_navbits($navbits);	
	eval('$navbar = "' . fetch_template('navbar') . '";');
}
else
{
	$navbar = render_navbar_template(construct_navbits($navbits));	
}

if (intval($vbulletin->versionnumber) == 3)
{
	// Begin the monster template
	$headinclude .= vB_Template::create('dbtech_ajaxthreads.css')->render();
}

// Finish the main template
$templater = vB_Template::create($page_template);
	$templater->register_page_templates();
	$templater->register('navclass', 		$navclass);
	$templater->register('HTML', 			$HTML);
	$templater->register('navbar', 			$navbar);
	$templater->register('pagetitle', 		$pagetitle);
	$templater->register('pagedescription', $pagedescription);
	$templater->register('template_hook', 	$template_hook);
	$templater->register('includecss', 		$includecss);
	$templater->register('year',			date('Y'));
	$templater->register('jQueryVersion',	AJAXTHREADS::$jQueryVersion);
	$templater->register('jQueryPath',		AJAXTHREADS::jQueryPath());
	$templater->register('version',			AJAXTHREADS::$version);
	$templater->register('versionnumber', 	AJAXTHREADS::$versionnumber);
	$templater->register('headinclude', 	$headinclude);
print_output($templater->render());