<?php
/*======================================================================*\
|| #################################################################### ||
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2012 Fillip Hannisdal AKA Revan/NeoRevan/Belazor 	  # ||
|| # All Rights Reserved. 											  # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # ---------------------------------------------------------------- # ||
|| # You are not allowed to use this on your server unless the files  # ||
|| # you downloaded were done so with permission.					  # ||
|| # ---------------------------------------------------------------- # ||
|| #################################################################### ||
\*======================================================================*/

// #######################################################################
// ######################## START MAIN SCRIPT ############################
// #######################################################################

// #############################################################################
if ($_POST['action'] == 'newposts')
{	
	require_once(DIR . '/includes/functions_bigthree.php');
	require_once(DIR . '/includes/class_postbit.php');
	if (intval($vbulletin->versionnumber) == 4)
	{
		if (!isset($vbulletin->userinfo['permissions']['cms']) AND $vbulletin->products['vbcms'])
		{
			require_once DIR . '/packages/vbcms/permissions.php';
			vBCMS_Permissions::getUserPerms();
		}
		
		require_once(DIR . '/includes/class_friendly_url.php');
		require_once(DIR . '/includes/class_bootstrap_framework.php');
		require_once(DIR . '/vb/types.php');
		vB_Bootstrap_Framework::init();		
	}
	
	$retval = array(
		'newPosts' 		=> array(),
		'editedPosts' 	=> array(),
		'deletedPosts' 	=> array(),
		'postIds' 		=> array(),
		'postVisible' 	=> array(),
	);

	$vbulletin->input->clean_array_gpc('p', array(
		'threadid' 		=> TYPE_UINT,
		'postids' 		=> TYPE_ARRAY,
		'postvisible' 	=> TYPE_ARRAY,
		'lastpostdate' 	=> TYPE_UINT,
	));
	
	// Just in case
	reset($vbulletin->GPC['postids']);
	
	// Back up this array
	$postids = $vbulletin->GPC['postids'];
	
	// Grab the first post we're dealing with here
	$firstpostid = key($vbulletin->GPC['postids']);
	
	/*
	// Sort the array in reverse
	krsort($vbulletin->GPC['postids'], SORT_NUMERIC);
	
	// Just in case
	reset($vbulletin->GPC['postids']);
	*/
	
	if (can_moderate($threadinfo['forumid']))
	{
		// We can mod this forum
		$coventry = '';
	}
	else
	{
		// We can't mod this forum, fetch coventry users
		$coventry = fetch_coventry('string');
		$coventry = ($coventry ? "AND post.userid NOT IN ($coventry)" : '');
	}
	
	if ($vbulletin->userinfo['postorder'] == 0)
	{
		$postorder = 'ASC';
	}
	else
	{
		$postorder = '';
	}
	
	// Grab forum permissions
	$forumperms = fetch_permissions($threadinfo['forumid']);
	$foruminfo = fetch_foruminfo($threadinfo['forumid']);
	
	$postbit_factory = new vB_Postbit_Factory();
	$postbit_factory->registry =& $vbulletin;
	$postbit_factory->forum =& $foruminfo;
	$postbit_factory->thread =& $threadinfo;
	$postbit_factory->cache = array();
	$postbit_factory->bbcode_parser = new vB_BbCodeParser($vbulletin, fetch_tag_list());		
	
	// filter out deletion notices if can't be seen
	$deletepost 	= (bool)($forumperms & $vbulletin->bf_ugp_forumpermissions['canseedelnotice'] OR can_moderate($threadinfo['forumid']));
	$approvepost 	= (bool)can_moderate($threadinfo['forumid'], 'canmoderateposts');
	
	if (!$deletepost AND !$approvepost)
	{
		// Fetch first post and all newer posts in this thread
		$posts = AJAXTHREADS::$db->fetchAssoc('
			SELECT postid, userid, title, pagetext, visible, dateline
			FROM $post AS post
			WHERE postid >= ?
				AND threadid = ?
				AND visible = 1
				:coventry
			ORDER BY postid :postOrder
		', array(
			$firstpostid,
			$vbulletin->GPC['threadid'],
			':coventry' 	=> $coventry,
			':postOrder' 	=> $postorder,
		));
	}
	else
	{
		$posts = AJAXTHREADS::$db->fetchAssoc('
			SELECT postid, userid, title, pagetext, visible, dateline
			FROM $post AS post
			WHERE postid >= ?
				AND threadid = ?
				AND visible IN (1 :deletePost :approvePost )
			ORDER BY postid :postOrder
		', array(
			$firstpostid,
			$vbulletin->GPC['threadid'],
			':deletePost' 	=> ($deletepost 	? ',2' : ''),
			':approvePost' 	=> ($approvepost 	? ',0' : ''),
			':postOrder' 	=> $postorder,
		));
	}
	
	foreach ($posts as $postid => $post)
	{
		if ($tachyuser = in_coventry($post['userid']) AND !can_moderate($threadinfo['forumid']))
		{
			// Skip tachy posts
			continue;
		}
		
		// Store post hash
		$post['posthash'] = md5($post['title'] . $post['pagetext']);
		
		if (isset($postids[$postid]))
		{
			// This post exists
			if ($post['posthash'] != $postids[$postid] OR $post['visible'] != $vbulletin->GPC['postvisible'][$postid])
			{
				// This post was edited
				$retval['editedPosts'][$postid] = $post['pagetext'];
			}
			
			// We've dealt with this post
			unset($postids[$postid]);
		}
		else
		{
			if (($post['userid'] == $vbulletin->userinfo['userid'] AND ($post['dateline'] > ($vbulletin->GPC['lastpostdate'] + $vbulletin->options['dbtech_ajaxthreads_refreshtimer']))
				) OR 
				($post['dateline'] > $vbulletin->GPC['lastpostdate']))
			{
				// This post didn't exist
				$postbit_obj =& $postbit_factory->fetch_postbit('dbtech_ajaxthreads_dummy');
				$postbit_obj->cachable = $post_cachable;
				
				// Store the new post's postbit
				$retval['newPosts'][$postid] = $postbit_obj->construct_postbit($post);
			}
		}
		
		// Store this in the post id list regardless
		$retval['postIds'][$postid] 	= $post['posthash'];
		$retval['postVisible'][$postid] = $post['visible'];
	}
	
	if (count($retval['newPosts']))
	{
		// We have new posts 
		require_once(DIR . '/includes/functions_bigthree.php');
		mark_thread_read($threadinfo, $foruminfo, $vbulletin->userinfo['userid'], TIMENOW);
	}
	
	if ($vbulletin->options['dbtech_ajaxthreads_maxposts'] > 0)
	{
		while (count($retval['postIds']) > $vbulletin->options['dbtech_ajaxthreads_maxposts'])
		{
			// Can't use array_shift due to element reordering
			reset($retval['postIds']);
			$key = key($retval['postIds']);
			
			$removed = $retval['postIds'][$key];
			unset($retval['postIds'][$key]);
			unset($retval['postVisible'][$key]);
			
			// Set as a deleted post
			$retval['deletedPosts'][$key] = $removed;			
		}
	}
	
	foreach ($postids as $postid => $posthash)
	{
		// This post was deleted
		$retval['deletedPosts'][$postid] = $posthash;
	}
	
	// Return the compiled list
	AJAXTHREADS::outputJSON($retval);
}