<?php
do
{
	if (STYLE_TYPE == 'mobile')
	{
		// Don't run on mobile
		break;
	}
	
	if (defined('VB_API') AND VB_API === true)
	{
		// Don't run on mobile
		break;
	}
	
	if (!$vbulletin->options['dbtech_ajaxthreads_active'])
	{
		// Mod deactivated
		break;
	}
	
	if (!$thread['open'])
	{
		// Thread is closed
		break;
	}
	
	if ((($vbulletin->GPC['pagenumber'] != ceil(($thread['replycount'] + 1) / $perpage)) AND $vbulletin->userinfo['postorder'] == 0) OR
		($vbulletin->GPC['pagenumber'] != 1 AND $vbulletin->userinfo['postorder'] == 1)
	)
	{
		// This thread shouldn't be automated
		break;
	}
	
	if (AJAXTHREADS::$permissions['isbannedgroup'])
	{
		// We can't use inline threads
		break;
	}
	
	if (AJAXTHREADS::$isPro)
	{
		if ($thread['replycount'] < $vbulletin->options['dbtech_ajaxthreads_minreplycount'])
		{
			// Not enough posts
			break;
		}
	}
	
	if (!AJAXTHREADS::$isPro)
	{
		// Lite-only shit
		$parentlist = explode(',', $foruminfo['parentlist']);
		if ($parentlist[0] == -1)
		{
			// This forum
			$noticeforum = $foruminfo['forumid'];		
		}
		else
		{
			$key = (count($parentlist) - 2);
			$noticeforum = $parentlist[$key];
		}
	}
	else
	{
		// This forum
		$noticeforum = $foruminfo['forumid'];
	}
	
	$canAutoUpdate 		= !(AJAXTHREADS::$permissions['cannotautoupdate'] 	OR $vbulletin->forumcache[$noticeforum]['dbtech_ajaxthreads_cannotautoupdate']);
	$canManualUpdate 	= !(AJAXTHREADS::$permissions['cannotmanualupdate'] OR $vbulletin->forumcache[$noticeforum]['dbtech_ajaxthreads_cannotmanualupdate']);
	
	if ($threadinfo['dbtech_ajaxthreads_refreshthread_override'])
	{
		// We'll do whatever the thread flag says
		$canAutoUpdate 	= $threadinfo['dbtech_ajaxthreads_refreshthread'];
	}
	else
	{
		// Disable refreshes if it's disabled for this thread
		$canAutoUpdate 	= (!$threadinfo['dbtech_ajaxthreads_refreshthread'] ? false : $canAutoUpdate);
	}
	
	// Override it with the vBOption - separated in case we need to revert the manager override bit
	$canAutoUpdate 		= ($vbulletin->options['dbtech_ajaxthreads_automatic_update'] ? $canAutoUpdate : false);
	
	if (!$canAutoUpdate AND !$canManualUpdate)
	{
		// No permissions
		break;
	}
	
	$ugs = fetch_membergroupids_array($vbulletin->userinfo);		
	if (!$ugs[0])
	{
		// Hardcode guests
		$ugs[0] = 1;
	}
	
	$duration = ($vbulletin->options['dbtech_ajaxthreads_durationtimer'] ? $vbulletin->options['dbtech_ajaxthreads_durationtimer'] 	: 300);
	foreach ($ugs as $usergroupid)
	{
		// Shorthand
		$newTime = AJAXTHREADS::$cache['usergroup']['durationtimer'][$usergroupid];
		
		if (!isset($newTime))
		{
			// No perm set for this UG
			continue;
		}
		
		if ($newTime == -1)
		{
			// Using default
			continue;
		}
		
		if ($newTime == 0)
		{
			// We're not idling, and nothing overrides this
			$duration = 0;
			break;
		}
		
		if ($newTime >= $duration)
		{
			// We're using a lower or equal timer already
			continue;
		}
		
		// Set the new duration time
		$duration = $newTime;
	}
	
	$jsphrases = array(
		'dbtech_ajaxthreads_refreshing_thread' 			=> $vbphrase['dbtech_ajaxthreads_refreshing_thread'],
		'dbtech_ajaxthreads_refreshing_thread_descr'	=> $vbphrase['dbtech_ajaxthreads_refreshing_thread_descr'],
		
	);
	AJAXTHREADS::jsEscapeString($jsphrases);
	
	foreach ($jsphrases as $varname => $phrase)
	{
		// Parse the phrase for the templates
		$vbphrase[$varname] = $phrase;
	}
	
	// Ensure this is set to at least 3 seconds
	$vbulletin->options['dbtech_ajaxthreads_refreshtimer'] = ($vbulletin->options['dbtech_ajaxthreads_refreshtimer'] < 3 ? 3 : $vbulletin->options['dbtech_ajaxthreads_refreshtimer']);
	
	if ($vbulletin->userinfo['postorder'] == 1)
	{
		ksort($ajaxThreadsPostIds, 		SORT_NUMERIC);
		ksort($ajaxThreadsPostVisible, 	SORT_NUMERIC);
	}
	
	$footer .= AJAXTHREADS::js('
		var ajaxThreadsOptions = ' . AJAXTHREADS::encodeJSON(array(
			'refreshDelay' 	=> ($vbulletin->options['dbtech_ajaxthreads_refreshtimer'] 	? $vbulletin->options['dbtech_ajaxthreads_refreshtimer'] 	: 5),
			'duration' 		=> $duration,
			'threadId' 		=> $thread['threadid'],
			'vbversion' 	=> intval($vbulletin->versionnumber),
			'direction' 	=> ($vbulletin->userinfo['postorder'] == 0 ? 'desc' : 'asc'),
			'postCount' 	=> ($thread['replycount'] + 1),
			'autoUpdate' 	=> ($canAutoUpdate 		? 1 : 0),
			'manualUpdate' 	=> ($canManualUpdate 	? 1 : 0),
			'autoUnidle' 	=> (int)$vbulletin->options['dbtech_ajaxthreads_automatic_unidle'],
		)) . ';
		var ajaxThreadsPostIds = ' . AJAXTHREADS::encodeJSON($ajaxThreadsPostIds) . ';
		var ajaxThreadsPostVisible = ' . AJAXTHREADS::encodeJSON($ajaxThreadsPostVisible) . ';
	', false, false);
	$footer .= '<script type="text/javascript" src="' . AJAXTHREADS::jQueryPath() . '"></script>';
	$footer .= AJAXTHREADS::js('', true, false);
	
	if ($vbulletin->options['dbtech_ajaxthreads_enablebar'])
	{
		$templater = vB_Template::create('dbtech_ajaxthreads_bar');
			$templater->register('autoUpdate', 		$canAutoUpdate);
			$templater->register('manualUpdate', 	$canManualUpdate);
		$bar = $templater->render();
		
		if (intval($vbulletin->versionnumber) == 3)
		{
			$poll 										.= $bar;
			$ad_location['ad_showthread_beforeqr'] 		.= $bar;
		}
		else
		{
			$template_hook['showthread_above_posts'] 	.= $bar;
			$forumjump 									.= $bar;
		}
	}
}
while (false);
?>